#include <SoftwareSerial.h> //블루투스를 사용하기위한 라이브러리
#include <Wire.h> //LCD를 사용하기위한 라이브러리
#include "LCD_I2C.h" //LCD를 사용하기위한 사용자 정의 라이브러리
#include "UPing.h" //초음파 센서를 사용하기위한 사용자 정의 라이브러리

SoftwareSerial bSerial(12, 13); //블루투스 모듈을 연결하는 핀 지정(아날로그 핀도 사용 가능), TX에 12, RX에 13을 연결
LCD_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

const int motorLeftF =11; // 왼쪽 모터의 전진 신호는 11번으로 정의
const int motorLeftB =10; // 왼쪽 모터의 후진 신호는 10번으로 정의
const int motorRightF=6; // 오른쪽 모터의 전진 신호는 6번으로 정의
const int motorRightB=9; // 오른쪽 모터의 전진 신호는 9번으로 정의

int speed = 255; //모터의 속도를 정의, 범위는 0~225, 100이상이 되어야 움직입니다.
unsigned char direction;

void setup() {
	bSerial.begin(9600); 

	lcd.backlight();
	lcd.begin(16, 2);
	lcd.setCursor(0, 0); //LCD 글자의 시작위치는 1번째줄 1번째 문자입니다.
	lcd.print("I'm Yellow Cat  ");
	lcd.setCursor(0, 1); //LCD 글자의 시작위치는 2번째줄 1번째 문자입니다.
	lcd.print("Waiting command");
	pinMode(motorRightF, OUTPUT);
	pinMode(motorRightB, OUTPUT);
	pinMode(motorLeftF, OUTPUT);
	pinMode(motorLeftB, OUTPUT);
	pinMode(motorRightF, OUTPUT);
	pinMode(motorRightB, OUTPUT);
	pinMode(motorLeftF, OUTPUT);
	pinMode(motorLeftB, OUTPUT);
}

void loop() { 
	char readed;
	while(bSerial.available()){
		readed=bSerial.read();
		if(readed=='S'){
			char digit_100=bSerial.read();
			char digit_10 =bSerial.read();
			char digit_1=bSerial.read();
			speed=(digit_100-'0')*100+(digit_10-'0')*10  + digit_1-'0';
			if(speed<0) speed=200;
			setDirection(direction); //변화된 속도를 적용하여 이전의 방향대로 간다.
			lcd.setCursor(0, 1); //LCD 글자의 시작위치는 2번째줄 1번째 문자입니다.
			lcd.print("set speed:");
			lcd.print(digit_100);			lcd.print(digit_10);			lcd.print(digit_1);
		}else{
			direction=readed;
			setDirection(direction);
		}
	}
}

void left(int speed){ //왼쪽 모터 제어 
	if (speed >= 0) { //전진
		digitalWrite(motorLeftB, LOW); //왼쪽 후진 신호 OFF
		analogWrite(motorLeftF, speed); //전진 신호 speed의 세기로 회전
	} else { //후진인 경우
		digitalWrite(motorLeftF, LOW); //왼쪽 후진 신호 OFF
		analogWrite(motorLeftB, -speed); //후진 신호 양수로 변경된 speed의 세기로 회전
	}
}
void right(int speed){ //오른쪽 모터 제어 
	if (speed >= 0) { //전진
		digitalWrite(motorRightB, LOW); //오른쪽 후진 신호 OFF
		analogWrite(motorRightF, speed); //전진 신호 speed의 세기로 회전 
	} else { //후진인 경우
		digitalWrite(motorRightF, LOW); //오른쪽 전진 신호 OFF
		analogWrite(motorRightB, -speed); //후진 신호 양수로 변경된 speed의 세기로 회전
	}
}

void setDirection(unsigned char d){
	lcd.setCursor(0, 1); //LCD 글자의 시작위치는 2번째줄 1번째 문자입니다.
	switch(d){
		case 'f': // f를 직진으로 정의
		lcd.print("Go forward!!!   ");
		left(speed);   right(speed);
		break;
		case 'b': // b를 후진으로 정의
		lcd.print("Going backward  ");
		left(-speed);   right(-speed); 
		break;
		case 'l': // l을 좌회전으로 정의
		lcd.print("Moving left     ");
		left(0);  //왼쪽 바퀴 정지
		right(speed); //오른쪽 바퀴 회전
		break;
		case 'r': // r을 우회전으로 정의
		lcd.print("Moving right    ");
		left(speed);   right(0);
		break;
		case 'L': //L을 반시계방향으로 회전으로 정의
		lcd.print("Turning left    ");
		left(-speed);  right(speed);
		break;
		case 'R': //R을 시계방향으로 회전으로 정의
		lcd.print("Turning right   ");
		left(speed);   right(-speed); 
		break;
		case 's': //s를 정지로 정의
		lcd.print("Stoped          ");
		left(0);right(0); //멈준다.
	}
}